#ifndef USART_H
#define USART_H 1
/*---------------------------------------------------------
File Name       : usart.h
Function        : Init, send and getc data with the USART
Created         : 10.12.2006
Version         : 0.02
Supported MCU   : ATmega8, ATmega16, ATmega32
                : ATtiny2313
-----------------------------------------------------------*/


#include <inttypes.h>


#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifdef UDR
    #define UDR0    UDR
    #define UCSR0A  UCSRA
    #define UCSR0B  UCSRB
    #define UCSR0C  UCSRC
    #define UBRR0L  UBRRL
    #define UBRR0H  UBRRH
    //Redefine Bits from UCSRA to UCSR0A
    #define RXC0    RXC
    #define TXC0    TXC
    #define UDRE0   UDRE
    #define FE0     FE
    #define DOR0    DOR
    #define UPE0    UPE
    #define U2X0    U2X
    #define MPCM0   MPCM
    //Redefine Bits from UCSRB to UCSR0B
    #define RXCIE0  RXCIE
    #define TXCIE0  TXCIE
    #define UDRIE0  UDRIE
    #define RXEN0   RXEN
    #define TXEN0   TXEN
    #define UCSZ02  UCSZ2
    #define RXB80   RXB8
    #define TXB80   TXB8
    //Redefine Bits from UCSRC to UCSR0C
    #define UMSEL00 UMSEL
    #define UPM01   UPM1
    #define UPM00   UPM0
    #define USBS0   USBS
    #define UCSZ01  UCSZ1
    #define UCSZ00  UCSZ0
    #define UCPOL0  UCPOL
#endif

#ifdef URSEL
    #define URSEL0 URSEL
#endif


//----------------------------------------------------------
// USART Functions
//----------------------------------------------------------
void usart_init(uint32_t baud, uint8_t charsize, char parity, uint8_t stopbits);

//----------------------------------------------------------
// USART Functions without IRQ and Buffer
//----------------------------------------------------------
void usart_putc(uint8_t data );
uint8_t usart_getc(void);
void usart_write(const char *str );
void usart_writeln(const char *str, char CR );
void usart_writepgm(const char *str );
void usart_writelnpgm(const char *str, char CR );
char usart_rxstat(void);


#endif
